
type TAI=
       record
       OutRead,InWrite:THandle;
       OutWrite,InRead:THandle;
       SA:TSecurityAttributes;
       AIname:PChar;
       SI:TStartupInfo;
       PI:TProcessInformation;
       BufferMe:ansistring;
       end;
var AI:array[1..2]of TAI;

procedure OpenPipe(sd:shortint);
begin
with AI[sd] do
  begin
  with SA do
    begin
    nLength:=sizeof(SA);
    lpSecurityDescriptor:=nil;
    bInheritHandle:=true;
    end;
  CreatePipe(OutRead,OutWrite,@SA,0);
  CreatePipe(InRead,InWrite,@SA,0);
  end;
end;

procedure ClosePipe(sd:shortint);
begin
with AI[sd] do
  begin
  CloseHandle(OutRead);
  CloseHandle(InWrite);
  CloseHandle(OutWrite);
  CloseHandle(InRead);
  end;
end;

procedure OpenAI(sd:shortint;s:string);
begin
OpenPipe(sd);
With AI[sd] do
  begin
  AIname:=s2pc(s);
  GetStartupInfo(@SI);
  with SI do
    begin
    cb:=sizeof(SI);
    dwFlags:=STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
    wShowWindow:=SW_HIDE;
    hStdInput:=InRead;
    hStdOutput:=OutWrite;
    hStdError:=OutWrite;
    end;
  DrawSit(sd,2);
  CreateProcess(AIname,nil,nil,nil,true,NORMAL_PRIORITY_CLASS,nil,nil,SI,PI);
  DrawSit(sd,3);
  end;
end;

procedure OpenAI(sd:shortint;lv:shortint);
var lvr:shortint;
begin
lvr:=lv;
if Size<>20 then
  begin
  lvr:=(lv div 2+1)*2;
  if lvr>26 then lvr:=26
  else if lvr>20 then lvr:=22
  else if lvr>16 then lvr:=16;
  end;
OpenAI(sd,'ai\ai'+i2s(lvr)+'.dat');
end;

procedure OpenAI(sd:shortint);
begin
OpenAI(sd,AILevel[sd]);
end;

procedure CloseAI(sd:shortint);
begin
with AI[sd] do
  begin
  TerminateProcess(PI.hProcess,0);
  CloseHandle(PI.hProcess);
  CloseHandle(PI.hThread);
  end;
ClosePipe(sd);
end;

const BUFFERLONG=32767;
var Buffer:array[0..Bufferlong-1]of char;
    BufferSize:DWord;
    BytesRead,BytesWrite:DWord;
    EofPos:longint;

procedure ReadAI(sd:shortint;var s:string);
begin
with AI[sd] do
  begin
  EofPos:=pos(#13,BufferMe);
  while (EofPos=0) {and (AITimeRemain+TimeDurance>0)}
        and (AISide[sd]=1) and (AISit[sd]=2) and (AINext[sd]=1) do
    begin
    if PeekNamedPipe(OutRead,@Buffer[0],BUFFERLONG,@BufferSize,nil,nil) then
      if BufferSize>0 then
        begin
        ReadFile(OutRead,Buffer[0],BufferSize,BytesRead,nil);
        BufferMe:=BufferMe+Copy(Buffer,0,BytesRead-1);
        end;
    EofPos:=pos(#13,BufferMe);
    AITimeRemain:=AITimeTurn[sd]+AITimeNow-GetTime();
    DrawTime(sd,AITimeRemain);
    sleep(1);
    end;
  if EofPos>0 then
    begin
    s:=Copy(BufferMe,1,EofPos);
    if s[1]=#10 then Delete(s,1,1);
    Delete(BufferMe,1,EofPos);
    end;
//writeln(sd,' @@@ ',s);
  end;
end;

function ReadAI(sd:shortint):string;
begin
ReadAI(sd,ReadAI);
end;

procedure WriteAI(sd:shortint;s:string);
begin
s:=s+#13+#10;
//writeln(sd,' *** ',s);
with AI[sd] do
  begin
  WriteFile(InWrite,s[1],length(s),BytesWrite,nil);
  end;
end;
