
var btmori:pbitmap;
    btm:array[1..6,1..3]of pbitmap;

var bgori:pbitmap;
    bg:array[0..4]of pbitmap;
    bgc:array[0..2]of dword;
    sz,zm:integer;

var DrawNow:boolean;

procedure DrawBMPbg(b:pbitmap;x,y,w,h:integer);
begin
while DrawNow do sleep(1);
DrawNow:=true;
BarTo(x,y,w,h,GetBGColor(),GetBGColor());
DrawBMP(b,x,y,w,h);
DrawNow:=false;
end;

procedure DrawChees(x,y,p:shortint);
begin
while DrawNow do sleep(1);
DrawNow:=true;
DrawBMP(bg[p],(x-1)*sz,(y-1)*sz);
DrawNow:=false;
end;

procedure DrawWin(x1,y1,x2,y2,p:shortint);
begin
DrawChees((4*x1+0*x2)div 4,(4*y1+0*y2)div 4,p+2);
DrawChees((3*x1+1*x2)div 4,(3*y1+1*y2)div 4,p+2);
DrawChees((2*x1+2*x2)div 4,(2*y1+2*y2)div 4,p+2);
DrawChees((1*x1+3*x2)div 4,(1*y1+3*y2)div 4,p+2);
DrawChees((0*x1+4*x2)div 4,(0*y1+4*y2)div 4,p+2);
Line(sz*x1-sz div 2,sz*y1-sz div 2,sz*x2-sz div 2,sz*y2-sz div 2,bgc[2]);
end;

procedure DrawPicBD(b:pbitmap;i,j:shortint);
begin
DrawBMPbg(b,zm*(i-1),zm*(j-1),zm,zm);
end;

procedure DrawStrBD(s:string;i,j:shortint);
begin
DrawTextXY(copy(s,1,15),zm*(i-1),zm*(j-1),GetFGColor,GetBGColor);
end;

procedure DrawPic(b:pbitmap;i,j:shortint);
begin
DrawBMPbg(b,sz*(size+1)+zm*(i-1),zm*(j-1),zm,zm);
end;

procedure DrawStr(s:string;i,j:shortint);
begin
DrawTextXY(copy(s,1,2),sz*(size+1)+zm*(i-1),zm*(j-1),GetFGColor,GetBGColor);
end;

procedure DrawPos(n,i,j:shortint);
var sPos:string;
begin
sPos:=i2s(n);
if (n>=10) and (n<=35) then sPos:=chr(n+55);
DrawTextXY(sPos,sz*(i-1)+round(length(sPos)*_fw/2),sz*(j-1),GetFGColor,GetBGColor);
end;

procedure LoadButtom();
begin
btmori:=LoadBMP('image\buttom.bmp',white);
for i:=1 to 6 do
  for j:=1 to 3 do
    btm[i,j]:=CopyBMPTo(btmori,(j-1)*128,(i-1)*128,128,128);
end;

procedure DrawSize();
begin
DrawStr(i2s(size),2,5);
end;

procedure DrawSkin();
begin
DrawPic(bg[0],2,6);
end;

procedure DrawMusic();
begin
DrawStr(i2s(MusicVol div 10)+i2s(MusicVol mod 10),2,7);
end;

procedure DrawSound();
begin
DrawStr(i2s(SoundVol div 10)+i2s(SoundVol mod 10),2,8);
end;

procedure DrawChange(sd:shortint);
begin
DrawPic(btm[AISide[sd]+5,1],1,sd*3+6);
end;

procedure DrawSideColor(pn,sd:shortint);
begin
DrawPic(bg[pn*(1-abs(1-sd))],2,9);
DrawPic(bg[pn*(1-abs(2-sd))],2,12);
DrawChees(Size+1,Size+1,ColorNow);
end;

procedure DrawScore(sd:shortint);
begin
DrawStr(i2s(AIScore[sd]),3,sd*3+6);
end;

procedure DrawLevel(sd:shortint);
var slevel:string;
begin
if AILevel[sd]<=9 then slevel:=i2s(10-AILevel[sd])+'d'
else slevel:=i2s(AILevel[sd]-9)+'k';
DrawStr(slevel,2,sd*3+7);
end;

procedure DrawTime(sd:shortint;t:longint);
begin
while(abs(t)>=100) do t:=t div 10;
DrawStr(i2s(t),2,sd*3+8);
end;

procedure DrawSit(sd:shortint;sit:shortint);
begin
case sit of
  1:DrawPic(btm[2,3],2,sd*3+8);
  2:DrawPic(btm[1,2],2,sd*3+8);
  3:DrawPic(btm[1,1],2,sd*3+8);
  4:DrawPic(btm[5,1],2,sd*3+8);
  5:DrawPic(btm[6,1],2,sd*3+8);
  9:DrawPic(btm[2,2],2,sd*3+8);
  end;
end;

procedure DrawButtom();
begin
for i:=1 to 4 do
  for j:=1 to 3 do
    DrawPic(btm[i,j],j,i);
DrawPic(btm[5,3],1,5);
DrawPic(btm[5,2],1,6);
DrawPic(btm[5,3],1,7);
DrawPic(btm[5,3],1,8);
DrawPic(btm[6,3],3,5);
DrawPic(btm[6,2],3,6);
DrawPic(btm[6,3],3,7);
DrawPic(btm[6,3],3,8);
DrawSize();
DrawSkin();
DrawMusic();
DrawSound();
DrawChange(1);
DrawChange(2);
DrawSideColor(ColorNow,SideNow);
DrawPic(btm[5,2],1,10);
DrawPic(btm[5,3],1,11);
DrawPic(btm[6,2],3,10);
DrawPic(btm[6,3],3,11);
DrawPic(btm[5,2],1,13);
DrawPic(btm[5,3],1,14);
DrawPic(btm[6,2],3,13);
DrawPic(btm[6,3],3,14);
DrawScore(1);
DrawScore(2);
DrawLevel(1);
DrawLevel(2);
DrawTime(1,AITimeTurn[1]);
DrawTime(2,AITimeTurn[2]);
end;

procedure DrawStep(i:longint);
begin
with Step[i] do DrawChees(x,y,p);
end;

procedure DrawStepAll();
begin
for i:=1 to StepNow do DrawStep(i);
end;

procedure DrawBoard();
begin
for i:=1 to Size do for j:=1 to Size do DrawChees(i,j,bd[i,j]);
SetFontSize(round(sz/2.4),sz);
for i:=1 to Size do DrawPos(i,i,Size+1);
for j:=1 to Size do DrawPos(j,Size+1,j);
SetFontSize(round(zm/2.4),zm);
end;

procedure DrawAll();
begin
bar(0,0,GetWidth,GetHeight,bgc[0],bgc[0]);
DrawBoard();
DrawButtom();
end;

procedure ResetWin(s:string);
begin
if bgori<>nil then ReleaseBMP(bgori);
bgori:=LoadBMP(s);
sz:=bgori^.height;
zm:=round(sz*(size+1)/14);
for i:=0 to 4 do
  begin
  if bg[i]<>nil then ReleaseBMP(bg[i]);
  bg[i]:=CopyBMPTo(bgori,sz*i,0,sz,sz);
  end;
for i:=0 to 2 do
  bgc[i]:=Windows.GetPixel(bgori^.DC,sz*5,i);
if GetHwnd<>0 then CloseWin();
CreateWin(sz*(size+1)+zm*3,sz*(size+1));
SetTitle(Title+TitleInitial);
SetBgColor(bgc[0]);
SetFGColor(bgc[1]);
SetFontSize(round(zm/2.4),zm);
DrawAll();
end;

procedure ResetWin();
begin
ResetWin('image\'+i2s(Skin)+'.bmp');
end;
